<?

/*
Script développé par :
Tibhix - tibhix _ at _ yahoo.fr

Merci de partager toute modification ou amélioration de ce script 
avec la communauté eedomus sur le forum : http://forum.eedomus.com

Principe :
 - ce script requiert que le script de la team Eedomus "Consommation 
   Enedis / Linky" soit actif et en fonctionnel
 - il faut également que vous ayez activé la récupération des données à la demi-heure 
   sur le site Enedis
 - il faut créer 2 peripheriques de type "Etat" : 
   --> un 1er périphérique qui va recueillir la donnée cumulée mesurée la veille (en Wh)
   --> un 2e périphérique qui va recueillir les données mesurées chaque 30 min la veille (en W)
 - une fois installé, il faut appeler ce script une fois par jour (après 8h, heure de MAJ 
   des donnees par Enedis)
   
Resultat :
 - les données sont réinjectées à la bonne date dans les periphériques de destination
 - Mais comme Enedis ne met à disposition que les données, le lendemain, vous
   aurez toujours 24h de retard

   
*/
//---------------------------------------------------//
// Donnees Usager à remplir                          //
//---------------------------------------------------//
//Identifiant usager                                 //
$usagerid="12345678913200";                          //
//---------------------------------------------------//
// Donnees Peripheriques à remplir                   //
//---------------------------------------------------//
// Peripherique de recueil des donnees quotidiennes  //
$linkyDailyPeriphID = 111111;                        //
// Peripherique de recueil des donnees 30 min        //
$linkyHourlyPeriphID = 2222222;                      //
//                                                   //
//---------------------------------------------------//


//URL to get XML value
$url="http://localhost/script/?exec=enedis_oauth.php&usage_point_id=".$usagerid;
$xml_result=httpQuery($url, $action = 'GET');

//-------------------------------
//Measurement day
//-------------------------------
// start/end
//---------------------
$start_day = xpath($xml_result,'//meter_reading/start');
$end_day = xpath($xml_result,'//meter_reading/end');
$unit_day = xpath($xml_result,'//usage_point[1]/usage_points/meter_reading/reading_type/unit');

// data (converted in kWh)
//---------------------
$value_data_kWh =xpath($xml_result,'//meter_reading/interval_reading/usage_points/value')/1000;

//Formatting data for assignment
$value_day = $start_day.' 00:00:00';

//-------------------------------
// Assignment to target periph (aggregated daily value)
//-------------------------------
$result1= setValue($linkyDailyPeriphID, $value_data_kWh, false, false, $value_day);
//-------------------------------
// Assignment of final value (to avoid wrong values)
//-------------------------------
$result2= setValue($linkyDailyPeriphID, 0, false, false, $end_day.' 00:00:00');


//-------------------------------
//Measurement every x min
//-------------------------------
// data collection
//---------------------
$interval_length_s = xpath($xml_result,'//usage_point[2]/usage_points/meter_reading/reading_type/interval_length');
$interval_length_min = $interval_length_s/60;
$unit_min = xpath($xml_result,'//usage_point[2]/usage_points/meter_reading/reading_type/unit');
$nb_measurements = xpath($xml_result,'count(//usage_point[2]/usage_points/meter_reading/interval_reading/usage_points)');

$string_values='';

for ($i=1;$i<=$nb_measurements;$i++) {
    $cValue = xpath($xml_result,'//usage_point[2]/usage_points/meter_reading/interval_reading/usage_points['.$i.']/value');
    $cTime = $interval_length_s * ($i-1);
    
    if($cTime < 3600){ 
       $heures = 0; 
       
       if($cTime < 60){$minutes = 0;} 
       else{$minutes = round($cTime / 60);} 
       
       $secondes = floor($cTime % 60); 
    } 
   else{ 
       $heures = floor($cTime / 3600); 
       $secondes = round($cTime % 3600); 
       $minutes = floor($secondes / 60); 
   } 
    $secondes = round($secondes % 60); 
    
    // Preparing format
    
    if (strlen($secondes)==1) {$secondes='0'.$secondes;}
    if (strlen($minutes)==1) {$minutes='0'.$minutes;}
    if (strlen($heures)==1) {$heures='0'.$heures;}
    
   
    $cTimeFinal = "$heures:$minutes:$secondes"; 
    
    $cDate = $start_day.' '.$cTimeFinal;
    $string_values.= $i.") ".$cTime."--->".$cDate."==>".$cValue."<br>";
    
    //-------------------------------
    // Assignment to target periph (x min values)
    //-------------------------------
    $result3= setValue($linkyHourlyPeriphID, $cValue, false, false, $cDate);
}

//-------------------------------
// Assignment of final value (to avoid wrong values)
//-------------------------------
$result4= setValue($linkyHourlyPeriphID, 0, false, false, $end_day.' 00:00:00');


// Echoing info (for info)
//---------------------
echo "Result : <br>";
echo $result1."<br>";
echo $result2."<br>";
echo $result3."<br>";
echo $result4."<br>";
echo "From ".$start_day." to ".$end_day.", Energy -->".$value_data_kWh." k".$unit_day."<br>";
echo "Details<br>";
echo "Measurement interval=".$interval_length_s." s (".$interval_length_min." min)<br>";
echo "Measurements number=".$nb_measurements."<br>";
echo "Unit=".$unit_min."<br>";
echo "Values=<br>".$string_values;


?>